/**********************************************************************
 *
 * ptmxdocaction.cpp -- 
 * A component of the Greenstone digital library software
 * from the New Zealand Digital Library Project at the
 * University of Waikato, New Zealand.
 *
 * Copyright (C) 2002  Stefan Boddie
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *
 *********************************************************************/

#include "ptmxdocaction.h"
#include "OIDtools.h"

ptmxdocaction::ptmxdocaction () {
}

ptmxdocaction::~ptmxdocaction () {
}

void ptmxdocaction::define_internal_macros (displayclass &disp, cgiargsclass &args, 
					    recptprotolistclass *protos, ostream &logout) {

  documentaction::define_internal_macros(disp, args, protos, logout);

  // set _pagepdf_ metadata

  if (!args["d"].empty()) {
    text_t &collection = args["c"];
    if (collection.empty()) return;
    recptproto *collectproto = protos->getrecptproto (collection, logout);
    if (collectproto == NULL) return;
    
    FilterResponse_t response;
    text_tset metadata;
    metadata.insert("pdf");
    if (get_info (args["d"], collection, metadata, false, collectproto, response, logout)) {
      text_t &pdf = response.docInfo[0].metadata["pdf"].values[0];
      if (!pdf.empty()) {
	disp.setmacro ("pagepdf", "Global", pdf);
      }
    }
  }
}

